Summary: Kernel for Win4Lin Package
Name: Kernel-Win4Lin1
Version: Caldera2.3
Release: 01
Group: Kernel
Copyright: GPL
Packager: Sherwin Kaplan <sherwin@trelos.com>
URL: http://www.trelos.com/
Source: /usr/src/OpenLinux/SOURCES/config.Caldera23
Patch: /usr/src/OpenLinux/SOURCES/mki-2210-caldera.patch
%description
This is a patched version of the linux kernel for use with the Win4Lin package.
It is based on the Caldera linux 2.2.10 kernel.
%prep
#
# Keep the previous version - just in case
#
rm -rf $RPM_BUILD_DIR/Caldera-patched-2.2.10.sav
if [ -e $RPM_BUILD_DIR/Caldera-patched-2.2.10 ]
then
    mv $RPM_BUILD_DIR/Caldera-patched-2.2.10 \
        $RPM_BUILD_DIR/Caldera-patched-2.2.10.sav
fi
#
# We Must have headers to do anything
#
if [ "`rpm -q linux-kernel-include-2.2.10-8`" != "linux-kernel-include-2.2.10-8" ]
then
    if [ -e /usr/src/OpenLinux/RPMS/linux-kernel-include-2.2.10-8.i386.rpm ]
    then
        rpm -i /usr/src/OpenLinux/RPMS/i386/linux-kernel-include-2.2.10-8.i386.rpm
    elif [ -e /mnt/cdrom/Packages/RPMS/linux-kernel-include-2.2.10-8.i386.rpm ]
    then
        rpm -i /mnt/cdrom/Packages/RPMS/linux-kernel-include-2.2.10-8.i386.rpm
    fi
fi
#
# Caldera does not install ncurses by default
# We need it to configure the kernel
#
if [ "`rpm -q ncurses-4.2-2`" != "ncurses-4.2-2" ]
then
    if [ -e /usr/src/OpenLinux/RPMS/ncurses-4.2-2.i386.rpm ]
    then
        rpm -i /usr/src/OpenLinux/RPMS/i386/ncurses-4.2-2.i386.rpm
    elif [ -e /mnt/cdrom/Packages/RPMS/ncurses-4.2-2.i386.rpm ]
    then
        rpm -i /mnt/cdrom/Packages/RPMS/ncurses-4.2-2.i386.rpm
    fi
fi
#
# Caldera does not install ncurses devel by default
# We need it to configure the kernel
#
if [ "`rpm -q ncurses-devel-4.2-2`" != "ncurses-devel-4.2-2" ]
then
    if [ -e /usr/src/OpenLinux/RPMS/ncurses-devel-4.2-2.i386.rpm ]
    then
        rpm -i /usr/src/OpenLinux/RPMS/i386/ncurses-devel-4.2-2.i386.rpm
    elif [ -e /mnt/cdrom/Packages/RPMS/ncurses-devel-4.2-2.i386.rpm ]
    then
        rpm -i /mnt/cdrom/Packages/RPMS/ncurses-devel-4.2-2.i386.rpm
    fi
fi
#
# Caldera splits the kernel into pieces
# We need at-least source-common, source-i386, and include
# If they have the cdrom mounted, also give them the docs
#
if [ "`rpm -q linux-source-common-2.2.10-8`" != "linux-source-common-2.2.10-8" ] \
    || [ "`rpm -q linux-source-i386-2.2.10-8`" != "linux-source-i386-2.2.10-8" ]
then
    if [ -e /usr/src/OpenLinux/RPMS/linux-source-common-2.2.10-8.i386.rpm ]
    then
        rpm -i --force --badreloc --relocate \
            /usr/src/=/usr/src/OpenLinux/BUILD/ \
            /usr/src/OpenLinux/RPMS/i386/linux-source-common-2.2.10-8.i386.rpm
        rpm -i --force --badreloc --relocate \
            /usr/src/=/usr/src/OpenLinux/BUILD/ \
            /usr/src/OpenLinux/RPMS/i386/linux-source-i386-2.2.10-8.i386.rpm
        rpm -i --force --badreloc --relocate \
            /usr/src/=/usr/src/OpenLinux/BUILD/ \
            /usr/src/OpenLinux/RPMS/i386/linux-kernel-include-2.2.10-8.i386.rpm
    elif [ -e /mnt/cdrom/Packages/RPMS/linux-source-common-2.2.10-8.i386.rpm ]
    then
        rpm -i --force --badreloc --relocate \
            /usr/src/=/usr/src/OpenLinux/BUILD/ \
            /mnt/cdrom/Packages/RPMS/linux-source-common-2.2.10-8.i386.rpm
        rpm -i --force --badreloc --relocate \
            /usr/src/=/usr/src/OpenLinux/BUILD/ \
            /mnt/cdrom/Packages/RPMS/linux-source-i386-2.2.10-8.i386.rpm
        rpm -i --force --badreloc --relocate \
            /usr/src/=/usr/src/OpenLinux/BUILD/ \
            /mnt/cdrom/Packages/RPMS/linux-kernel-include-2.2.10-8.i386.rpm
        rpm -i --force --badreloc --relocate \
            /usr/src/=/usr/src/OpenLinux/BUILD/ \
            /mnt/cdrom/Packages/RPMS/linux-kernel-doc-2.2.10-8.i386.rpm
    else
        echo " Unable to find the following RPMS"
        echo ""
        echo "   /mnt/cdrom/Packages/RPMS/linux-source-common-2.2.10-8.i386.rpm"
        echo "   /mnt/cdrom/Packages/RPMS/linux-source-i386-2.2.10-8.i386.rpm"
        echo "   /mnt/cdrom/Packages/RPMS/linux-kernel-include-2.2.10-8.i386.rpm"
        echo ""
        echo " Please mount the Caldera 2.2 CD-ROM #1 on mnt/cdrom"
        echo " and run:  'rpm -i Kernel-Win4Lin1-Caldera2.3-1.i386.rpm'  again!!!"
        echo ""
        exit 1
    fi
else 
    cp -Rpd /usr/src/linux-2.2.10/ $RPM_BUILD_DIR/linux-2.2.10/
fi
cd $RPM_BUILD_DIR
mv linux-2.2.10/ Caldera-patched-2.2.10
cd Caldera-patched-2.2.10
patch -p1 <$RPM_SOURCE_DIR/mki-2210-caldera.patch
cp $RPM_SOURCE_DIR/config.Caldera23 .
make clean
make distclean
cp config.Caldera23 .config
echo "EX Y"  > configit
make menuconfig < configit
%build
cd Caldera-patched-2.2.10
make dep
make bzImage
%install
#linuxW4L install in boot
cp $RPM_BUILD_DIR/Caldera-patched-2.2.10/arch/i386/boot/bzImage /boot/win4lin
cp $RPM_BUILD_DIR/Caldera-patched-2.2.10/System.map /boot/System.map.win4lin
%post
if [ "`cat /proc/version`" != \
	"Linux version 2.2.10 (root@tuvok.calderasystems.com) (gcc version egcs-2.91.66 19990314 (egcs-1.1.2 release)) #1 SMP Tue Aug 10 19:01:45 MDT 1999" ];
then
  echo " "
  echo "WARNING!!!"
  echo "You are NOT running the original Caldera 2.2.10-8 kernel"
  echo "The win4lin kernel may fail to boot!"
  echo "If this happens, reboot, do not select the win4lin kernel"
  echo "at the LILO prompt. Then your machine will boot normally."
  echo "See the Release Notes for further information."
  echo " "
fi
#edit lilo.conf
echo "# Added by TreLOS for Win4Lin kernel" > /tmp/lilowin4lin
echo "image = /boot/win4lin" >> /tmp/lilowin4lin
echo "label = win4lin" >> /tmp/lilowin4lin
echo "vga = 274" >> /tmp/lilowin4lin
echo "append = \"debug=2 noapic nosmp\"" >> /tmp/lilowin4lin
echo "root = " >> /tmp/lilowin4lin
RDEV=`rdev |cut -d' ' -f1`
cp /etc/lilo.conf /etc/lilo.conf.win4lin
cat /tmp/lilowin4lin | sed -e "s,root =,root = $RDEV," >> /etc/lilo.conf
#run lilo
/sbin/lilo -D win4lin
rm /tmp/lilowin4lin
if [ -e /boot/System.map ];
then
  mv /boot/System.map /boot/System.map.pre-win4lin
fi
ln -s /boot/System.map.win4lin /boot/System.map
echo ""
echo "In order to run win4lin..."
echo "You must first reboot the system."
echo ""
echo "      Please remove bootable CD-ROM's "
echo "      and Floppies before you reboot "
echo ""
%postun
mv /etc/lilo.conf.win4lin /etc/lilo.conf
#restore the System.map
if [ -L /boot/System.map ];
then
  rm /boot/System.map
fi
if [ -e /boot/System.map.pre-win4lin ];
then
  mv /boot/System.map.pre-win4lin /boot/System.map 
fi
#run lilo to restore original system
/sbin/lilo
%files
/boot/win4lin
/boot/System.map.win4lin
