# SCCSID(@(#)Kernel-Win4Lin1-RedHat6.1-20.spec	1.2) Modified 13:07:13 11/10/99
Summary: Kernel for Win4Lin Package
Name: Kernel-Win4Lin1
Version: RedHat6.1
Release: 20
Group: Kernel
Copyright: GPL
Packager: Sherwin Kaplan <sherwin@trelos.com>
URL: http://www.trelos.com/
Source: /usr/src/redhat/SOURCES/config.REDHAT61
Patch: /usr/src/redhat/SOURCES/mki-2212-redhat.patch
%description
This is a patched version of the linux kernel for use with the Win4Lin package.
It is based on the RedHat linux 2.2.12 kernel.
%prep
#
# Keep the previous version - just in case
#
rm -rf $RPM_BUILD_DIR/RedHat-patched-2.2.12-20.sav
if [ -e $RPM_BUILD_DIR/RedHat-patched-2.2.12-20 ]
then
    mv $RPM_BUILD_DIR/RedHat-patched-2.2.12-20 \
        $RPM_BUILD_DIR/RedHat-patched-2.2.12-20.sav
fi
#
# We Must have headers to do anything
# So we are going to install them whatever rpm says
#
if [ "`rpm -q kernel-headers-2.2.12-20`" != "kernel-headers-2.2.12-20" ]
    [ ! -e /usr/src/linux-2.2.12/include ]
then
    if [ -e /usr/src/redhat/RPMS/i386/kernel-headers-2.2.12-20.i386.rpm ]
    then
        rpm -i --force \
            /usr/src/redhat/RPMS/i386/kernel-headers-2.2.12-20.i386.rpm
    elif [ -e /mnt/cdrom/RedHat/RPMS/kernel-source-2.2.12-20.i386.rpm ]
    then
        rpm -i --force \
            /mnt/cdrom/RedHat/RPMS/kernel-source-2.2.12-20.i386.rpm
    fi
fi
if [ "`rpm -q kernel-source-2.2.12-20`" != "kernel-source-2.2.12-20" ]
    [ ! -e /usr/src/linux-2.2.12/Makefile ]
then
    if [ -e /usr/src/redhat/RPMS/i386/kernel-source-2.2.12-20.i386.rpm ]
    then
        rpm -i --force --badreloc --relocate /usr/src/=/usr/src/redhat/BUILD/ \
            /usr/src/redhat/RPMS/i386/kernel-headers-2.2.12-20.i386.rpm
        rpm -i --force --badreloc --relocate /usr/src/=/usr/src/redhat/BUILD \
            /usr/src/redhat/RPMS/i386/kernel-source-2.2.12-20.i386.rpm
    elif [ -e /mnt/cdrom/RedHat/RPMS/kernel-source-2.2.12-20.i386.rpm ]
    then
        rpm -i --force --badreloc --relocate /usr/src/=/usr/src/redhat/BUILD/ \
            /mnt/cdrom/RedHat/RPMS/kernel-headers-2.2.12-20.i386.rpm
        rpm -i --force --badreloc --relocate /usr/src/=/usr/src/redhat/BUILD \
            /mnt/cdrom/RedHat/RPMS/kernel-source-2.2.12-20.i386.rpm
    else
        echo " Unable to find the following RPMS"
        echo ""
        echo "    /mnt/cdrom/RedHat/RPMS/kernel-source-2.2.12-20.i386.rpm"
        echo "    /mnt/cdrom/RedHat/RPMS/kernel-headers-2.2.12-20.i386.rpm"
        echo ""
        echo " Please mount the Red Hat 6.1 CD-ROM #1 on mnt/cdrom"
        echo " and run:  'rpm -i Kernel-Win4Lin1-RedHat6.1-20.i386.rpm'  again!!!"
        echo ""
        exit 1
    fi
else 
    cp -Rpd /usr/src/linux-2.2.12/ $RPM_BUILD_DIR/linux-2.2.12/
fi
cd $RPM_BUILD_DIR
mv linux-2.2.12/ RedHat-patched-2.2.12-20
cd RedHat-patched-2.2.12-20
patch -p1 <$RPM_SOURCE_DIR/mki-2212-redhat.patch
cp $RPM_SOURCE_DIR/config.REDHAT61 .
make clean
make distclean
cp config.REDHAT61 .config
echo "EX Y"  > configit
make menuconfig < configit
%build
cd $RPM_BUILD_DIR/RedHat-patched-2.2.12-20
make dep
make bzImage
%install
#linuxW4L install in boot
cp $RPM_BUILD_DIR/RedHat-patched-2.2.12-20/arch/i386/boot/bzImage /boot/win4lin
cp $RPM_BUILD_DIR/RedHat-patched-2.2.12-20/System.map /boot/System.map.win4lin
%post
if [ "`cat /proc/version`" != \
    "Linux version 2.2.12-20 (root@porky.devel.redhat.com) (gcc version egcs-2.91.66 19990314/Linux (egcs-1.1.2 release)) #1 Mon Sep 27 10:40:35 EDT 1999" ];
then
    echo ""
    echo "WARNING!!!"
    echo "You are NOT running the original Red Hat 2.2.12-20 kernel"
    echo "The win4lin kernel may fail to boot!"
    echo "If this happens, reboot, do not select the win4lin kernel"
    echo "at the LILO prompt. Then your machine will boot normally."
    echo "See the Release Notes for further information."
    echo ""
fi
#
# Edit the lilo.conf
#
echo "# Added by TreLOS for Win4Lin kernel" > /tmp/lilowin4lin
echo "image = /boot/win4lin" >> /tmp/lilowin4lin
echo "label = win4lin" >> /tmp/lilowin4lin
grep "initrd" /etc/lilo.conf > /dev/null
if [ $? = 0 ];
    then
    echo "initrd=/boot/initrd-2.2.12-20.img" >> /tmp/lilowin4lin
fi
echo "root = " >> /tmp/lilowin4lin
RDEV=`rdev |cut -d' ' -f1`
cp /etc/lilo.conf /etc/lilo.conf.win4lin
cat /tmp/lilowin4lin | sed -e "s,root =,root = $RDEV," >> /etc/lilo.conf
#run lilo
/sbin/lilo -D win4lin 
rm /tmp/lilowin4lin
if [ -e /boot/System.map ];
then
    mv /boot/System.map /boot/System.map.pre-win4lin
fi
ln -s /boot/System.map.win4lin /boot/System.map
echo ""
echo "In order to run win4lin..."
echo "You must first reboot the system."
echo ""
echo "      Please remove bootable CD-ROM's "
echo "      and Floppies before you reboot "
echo ""
%postun
mv /etc/lilo.conf.win4lin /etc/lilo.conf
#
# Restore the System.map
#
if [ -L /boot/System.map ];
then
    rm /boot/System.map
fi
if [ -e /boot/System.map.pre-win4lin ];
then
    mv /boot/System.map.pre-win4lin /boot/System.map 
fi
#
# Run lilo to restore original system
#
/sbin/lilo
%files
/boot/win4lin
/boot/System.map.win4lin

