Summary: Kernel for Win4Lin Package
Name: Kernel-Win4Lin1
Version: SuSE6.1
Release: 01
Group: Kernel
Copyright: GPL
Packager: Sherwin Kaplan <sherwin@trelos.com>
URL: http://www.trelos.com/
Source: /usr/src/packages/SOURCES/config.SuSE
Patch: /usr/src/packages/SOURCES/mki-suse227.patch
%description
This is a patched version of the linux kernel for use with the Win4Lin package.
It is based on the SuSE linux 2.2.7 kernel.
%prep
#
# Keep the previous version - just in case
#
rm -rf $RPM_BUILD_DIR/SuSE-patched-2.2.7-01.sav
if [ -e $RPM_BUILD_DIR/SuSE-patched-2.2.7-01 ]
then
    mv $RPM_BUILD_DIR/SuSE-patched-2.2.7-01 \
        $RPM_BUILD_DIR/SuSE-patched-2.2.7-01.sav
fi
if [ "`rpm -q lx_suse-2.2.7.SuSE-1`" != "lx_suse-2.2.7.SuSE-1" ]
then
    if [ -e /usr/src/packages/RPMS/i386/lx_suse.rpm ]
    then
        rpm -i --force --badreloc --relocate /usr/src/=/usr/src/packages/BUILD \
            /usr/src/packages/RPMS/i386/kernel-source-2.2.5-15.i386.rpm
    elif [ -e /cdrom/suse/d1/lx_suse.rpm ]
    then
        rpm -i --force --badreloc --relocate /usr/src/=/usr/src/packages/BUILD \
            /cdrom/suse/d1/lx_suse.rpm
    else
        echo " Unable to find the following RPM"
        echo ""
        echo "/cdrom/suse/d1/lx_suse.rpm"
        echo ""
        echo " Please mount the SuSE 6.1 CD-ROM #1 on /cdrom"
        echo " and run:  'rpm -i Kernel-Win4Lin1-SuSE6.1-01.i386.rpm'  again!!!"
        echo ""
        exit 1
    fi
else 
    cp -Rpd /usr/src/linux-2.2.7.SuSE/ $RPM_BUILD_DIR/linux-2.2.7.SuSE/
fi
cd $RPM_BUILD_DIR
mv linux-2.2.7.SuSE/ SuSE-patched-2.2.7-01
cd SuSE-patched-2.2.7-01
patch -p1 <$RPM_SOURCE_DIR/mki-suse227.patch
cp $RPM_SOURCE_DIR/config.SuSE .
make clean
make distclean
cp config.SuSE .config
echo "EX Y"  > configit
make menuconfig < configit
%build
cd $RPM_BUILD_DIR/SuSE-patched-2.2.7-01/
make dep
make bzImage
%install
#linuxW4L install in boot
cp $RPM_BUILD_DIR/SuSE-patched-2.2.7-01/arch/i386/boot/bzImage /boot/win4lin
cp $RPM_BUILD_DIR/SuSE-patched-2.2.7-01/System.map /boot/System.map.win4lin
%post
# SuSE has numerous kernels - let's just test the beginning of the string
grep "Linux version 2.2.7 (root@Mandelbrot.suse.de)" /proc/version > /dev/null
if [ $? != 0 ];
then
  echo " "
  echo "WARNING!!!"
  echo "You are NOT running the original SuSE 2.2.7 kernel"
  echo "The win4lin kernel may fail to boot!"
  echo "If this happens, reboot, do not select the win4lin kernel"
  echo "at the LILO prompt. Then your machine will boot normally."
  echo "See the Release Notes for further information."
  echo " "
fi
#edit lilo.conf
echo "# Added by TreLOS for Win4Lin kernel" > /tmp/lilowin4lin
echo "image = /boot/win4lin" >> /tmp/lilowin4lin
echo "label = win4lin" >> /tmp/lilowin4lin
echo "root = " >> /tmp/lilowin4lin
RDEV=`rdev |cut -d' ' -f1`
cp /etc/lilo.conf /etc/lilo.conf.win4lin
cat /tmp/lilowin4lin | sed -e "s,root =,root = $RDEV," >> /etc/lilo.conf
#run lilo
/sbin/lilo -D win4lin
rm /tmp/lilowin4lin
if [ -e /boot/System.map ];
then
  mv /boot/System.map /boot/System.map.pre-win4lin
fi
ln -s /boot/System.map.win4lin /boot/System.map
echo ""
echo "In order to run win4lin..."
echo "You must first reboot the system."
echo ""
echo "      Please remove bootable CD-ROM's "
echo "      and Floppies before you reboot "
echo ""
%postun
mv /etc/lilo.conf.win4lin /etc/lilo.conf
#restore the System.map
if [ -L /boot/System.map ];
then
  rm /boot/System.map
fi
if [ -e /boot/System.map.pre-win4lin ];
then
  mv /boot/System.map.pre-win4lin /boot/System.map 
fi
#run lilo to restore original system
/sbin/lilo
%files
/boot/win4lin
/boot/System.map.win4lin
