#!/bin/sh
# SCCSID(@(#)install-kernel-srpm.sh	1.2) Modified 19:57:40 2/3/00
#
# Kernel-Win4Lin1-Install-SRPM.sh
#
##############################################################################
#                                                                            #
#         SRPM selection and Installation Script for TreLOS win4lin           #
#                                                                            #
##############################################################################
#
#         TreLOS, Inc. 
#

VERSION=`cat /proc/version`
CALDERA22="Linux version 2.2.5 (root@knob.calderasystems.com)"
CALDERA23="Linux version 2.2.10 (root@tuvok.calderasystems.com)"
COREL10="Linux version 2.2.12 (root@cricket)"
MANDRAKE70="Linux version 2.2.14-15mdk (root@kenobi.mandrakesoft.com)"
REDHAT15="Linux version 2.2.5-15 (root@porky.devel.redhat.com)"
REDHAT61="Linux version 2.2.12-20 (root@porky.devel.redhat.com)"
SUSE="Linux version 2.2.7 (root@Mandelbrot.suse.de)"
SUSE62="Linux version 2.2.10 (root@Mandelbrot.suse.de)"
SUSE63="Linux version 2.2.13 (root@euler)"

if [ `grep -q "$CALDERA22" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-Caldera2.2-01.src.rpm
SPEC=/usr/src/OpenLinux/SPECS/Kernel-Win4Lin1-Caldera2.2-01.spec
RPMi386=/usr/src/OpenLinux/RPMS/i386/Kernel-Win4Lin1-Caldera2.2-01.i386.rpm

elif [ `grep -q "$CALDERA23" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-Caldera2.3-01.src.rpm
SPEC=/usr/src/OpenLinux/SPECS/Kernel-Win4Lin1-Caldera2.3-01.spec
RPMi386=/usr/src/OpenLinux/RPMS/i386/Kernel-Win4Lin1-Caldera2.3-01.i386.rpm

elif [ `grep -q "$COREL10" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-Corel1.0-1.src.rpm
SPEC=/usr/src/redhat/SPECS/Kernel-Win4Lin1-Corel1.0.spec
RPMi386=/usr/src/redhat/RPMS/i386/Kernel-Win4Lin1-Corel1.0-1.i386.rpm
DEBi386=/usr/src/redhat/RPMS/i386/kernel-win4lin1_Corel1.0-2_i386.deb

elif [ `grep -q "$MANDRAKE70" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-Mandrake7.0-15.src.rpm
SPEC=/usr/src/RPM/SPECS/Kernel-Win4Lin1-RedHat6.0-15.spec
RPMi386=/usr/src/RPM/RPMS/i386/Kernel-Win4Lin1-Mandrake7.0-15.i686.rpm

elif [ `grep -q "$REDHAT15" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-RedHat6.0-15.src.rpm
SPEC=/usr/src/redhat/SPECS/Kernel-Win4Lin1-RedHat6.0-15.spec
RPMi386=/usr/src/redhat/RPMS/i386/Kernel-Win4Lin1-RedHat6.0-15.i386.rpm

elif [ `grep -q "$REDHAT61" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-RedHat6.1-20.src.rpm
SPEC=/usr/src/redhat/SPECS/Kernel-Win4Lin1-RedHat6.1-20.spec
RPMi386=/usr/src/redhat/RPMS/i386/Kernel-Win4Lin1-RedHat6.1-20.i386.rpm

elif [ `grep -q "$SUSE" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-SuSE6.1-01.src.rpm
SPEC=/usr/src/packages/SPECS/Kernel-Win4Lin1-SuSE6.1-01.spec
RPMi386=/usr/src/packages/RPMS/i386/Kernel-Win4Lin1-SuSE6.1-01.i386.rpm

elif [ `grep -q "$SUSE62" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-SuSE6.2-01.src.rpm
SPEC=/usr/src/packages/SPECS/Kernel-Win4Lin1-SuSE6.2-01.spec
RPMi386=/usr/src/packages/RPMS/i386/Kernel-Win4Lin1-SuSE6.2-01.i386.rpm

elif [ `grep -q "$SUSE63" /proc/version ; echo $?` -eq 0 ];
then
SRPM=SRPMS/Kernel-Win4Lin1-SuSE6.3-01.src.rpm
SPEC=/usr/src/packages/SPECS/Kernel-Win4Lin1-SuSE6.3-01.spec
RPMi386=/usr/src/packages/RPMS/i386/Kernel-Win4Lin1-SuSE6.3-01.i386.rpm

else
    echo ""
    echo "You are running a linux kernel that does not currently have"
    echo "an available Win4Lin source RPM."
    echo ""
    echo "Please see the Release Notes, for more information, on how to"
    echo "use alternative kernels, or how to patch your current kernel."
    echo ""
    exit
fi

echo ""
echo "You appear to be running the following linux kernel:"
echo ""
echo "	" $VERSION
echo ""

while [ 1 ];
do
echo ""
echo -n "Would you like to install the win4lin kernel source patch? (Y or N (or RET for Y)) " 
read YORN
echo ""
YORN=${YORN:=Y}

if [ $YORN = "Y" ] || [ $YORN = "y" ]; 
then
echo "Installing $SRPM : the Win4Lin kernel source patch ...Please Wait..."
rpm -i $SRPM
rpm -ba $SPEC
if [ `grep -q "$COREL10" /proc/version ; echo $?` -eq 0 ];
then
alien -c $RPMi386
dpkg -i $DEBi386
else
rpm -i $RPMi386
fi
echo ""
break;
elif [ $YORN = "N" ] || [ $YORN = "n" ]; 
then
echo ""
echo "Your System has not been modified!"
echo ""
break;
else
echo ""
echo "...Please answer (Y or N (or RET for Y))! "
echo ""
fi
done

