#!/bin/sh
# SCCSID(@(#)install-kernel.sh	1.6) Modified 19:57:13 2/3/00
##############################################################################
#                                                                            #
#         RPM selection and Installation Script for TreLOS Win4Lin           #
#                                                                            #
##############################################################################
#
#         TreLOS, Inc. 
#

VERSION=`cat /proc/version`
CALDERA22="Linux version 2.2.5 (root@knob.calderasystems.com)"
CALDERA23="Linux version 2.2.10 (root@tuvok.calderasystems.com)"
COREL10="Linux version 2.2.12 (root@cricket)"
MANDRAKE70="Linux version 2.2.14-15mdk (root@kenobi.mandrakesoft.com)"
REDHAT15="Linux version 2.2.5-15 (root@porky.devel.redhat.com)"
REDHAT61="Linux version 2.2.12-20 (root@porky.devel.redhat.com)"
SUSE="Linux version 2.2.7 (root@Mandelbrot.suse.de)"
SUSE62="Linux version 2.2.10 (root@Mandelbrot.suse.de)"
SUSE63="Linux version 2.2.13 (root@euler)"

if [ `id -u` -ne 0 ];
then
echo ""
echo "This script must be run as root - please su - and try again."
echo ""
exit 1
fi

if [ `grep -q "$CALDERA22" /proc/version ; echo $?` -eq 0 ];
then
RPM=RPMS/Kernel-Win4Lin1-Caldera2.2-01.i386.rpm

elif [ `grep -q "$CALDERA23" /proc/version ; echo $?` -eq 0 ];
then
RPM=RPMS/Kernel-Win4Lin1-Caldera2.3-01.i386.rpm

elif [ `grep -q "$COREL10" /proc/version ; echo $?` -eq 0 ];
then
DEB=RPMS/kernel-win4lin1_Corel1.0-2_i386.deb

elif [ `grep -q "$MANDRAKE70" /proc/version ; echo $?` -eq 0 ];
then
RPM=RPMS/Kernel-Win4Lin1-Mandrake7.0-15.i686.rpm

elif [ `grep -q "$REDHAT15" /proc/version ; echo $?` -eq 0 ];
then
RPM=RPMS/Kernel-Win4Lin1-RedHat6.0-15.i386.rpm

elif [ `grep -q "$REDHAT61" /proc/version ; echo $?` -eq 0 ];
then
RPM=RPMS/Kernel-Win4Lin1-RedHat6.1-20.i386.rpm

elif [ `grep -q "$SUSE" /proc/version ; echo $?` -eq 0 ];
then
RPM=RPMS/Kernel-Win4Lin1-SuSE6.1-01.i386.rpm

elif [ `grep -q "$SUSE62" /proc/version ; echo $?` -eq 0 ];
then
RPM=RPMS/Kernel-Win4Lin1-SuSE6.2-01.i386.rpm

elif [ `grep -q "$SUSE63" /proc/version ; echo $?` -eq 0 ];
then
RPM=RPMS/Kernel-Win4Lin1-SuSE6.3-01.i386.rpm

else
    echo ""
    echo "You do not appear to be running a standard kernel."
    echo ""
    echo "If you want to use one of Win4Lin's kernels, locate the"
    echo "appropriate kernel in the ./RPMS/  subdirectory and use"
    echo " rpm -i to install it."
    echo ""
    echo "Please see the Release Notes, for more information, on how to"

    echo "build and install a Win4Lin enhanced kernel, or how to patch"
    echo "your current kernel."
    echo ""
    exit 1
fi
if [ ! -f $RPM ]
then
	echo ""
	echo "Error, the current directory is not correct."
	echo "Cannot find the Win4Lin kernel RPM file."
	echo "($RPM)"
	echo "This script must be run from the LINUX directory on the CD".
	exit 1
fi

echo ""
echo "You appear to be running the following linux kernel:"
echo ""
echo "	" $VERSION
echo ""

while [ 1 ];
do
echo ""
echo -n "Would you like to install the Win4Lin kernel RPM? (Y or N (or RET for Y)) " 
read YORN
echo ""
YORN=${YORN:=Y}

if [ $YORN = "Y" ] || [ $YORN = "y" ]; 
then
if [ `grep -q "$COREL10" /proc/version ; echo $?` -eq 0 ];
then
echo "Installing $DEB : the Win4Lin kernel DEB ...Please Wait..."
dpkg -i $DEB
else
echo "Installing $RPM : the Win4Lin kernel RPM ...Please Wait..."
rpm -i $RPM
fi
echo ""

if [ ! -e ../Win4Lin/install-win4lin.sh ]
then
echo ""
echo "Error: The file install-win4lin.sh was not found."
echo "Cannot create /usr/bin/install-win4lin.sh, so the next step after"
echo "the reboot cannot be done to install the Win4Lin RPM package."
echo ""
exit 1
fi

WIN4LIN_CD_DIR=`pwd | sed -e 's#/LINUX\$##'`
WIN4LIN_CD_DEV=`mount |grep $WIN4LIN_CD_DIR |cut -d' ' -f1`
rm -f /usr/bin/install-win4lin.sh
echo "#!/bin/sh" > /usr/bin/install-win4lin.sh
echo "WIN4LIN_CD_DIR=$WIN4LIN_CD_DIR" >> /usr/bin/install-win4lin.sh
echo "WIN4LIN_CD_DEV=$WIN4LIN_CD_DEV" >> /usr/bin/install-win4lin.sh
echo "`cat ../Win4Lin/install-win4lin.sh`" >> /usr/bin/install-win4lin.sh

chmod 555 /usr/bin/install-win4lin.sh

echo "In Order to use the Win4Lin enhanced kernel you need to Reboot"
echo -n "Would you like to reboot Now? (Y or N (or RET for Y)) " 
read YORN
echo ""
YORN=${YORN:=Y}

if [ $YORN = "Y" ] || [ $YORN = "y" ]; 
then
sync;reboot
fi
break;
elif [ $YORN = "N" ] || [ $YORN = "n" ]; 
then
echo ""
echo "Your System has not been modified!"
echo ""
break;
else
echo ""
echo "...Please answer (Y or N (or RET for Y))! "
echo ""
fi
done

