//  FreeMWare: run multiple x86 operating systems concurrently
//  Copyright (C) 1999  Kevin P. Lawton
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of the GNU Lesser General Public
//  License as published by the Free Software Foundation; either
//  version 2 of the License, or (at your option) any later version.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA





#ifndef __HOST_BEOS_H__
#define __HOST_BEOS_H__

#include <SupportDefs.h>

typedef uint8 u8;
typedef uint16 u16;
typedef uint16 __u16;
typedef uint32 u32;
typedef uint32 __u32;

// These macros were snarfed out of the newer Linux kernel.
// They were not defined in previous ones.
#define read_cr0() ({ \
        unsigned int __dummy; \
        __asm__( \
                "movl %%cr0,%0\n\t" \
                :"=r" (__dummy)); \
        __dummy; \
})
#define write_cr0(x) \
        __asm__("movl %0,%%cr0": :"r" (x))

#define read_flags() ({ \
        unsigned int __dummy; \
        __asm__( \
				"pushfl\n\t" \
				"popl	%0\n\t" \
                :"=r" (__dummy)); \
        __dummy; \
})
#define write_flags(x) \
        __asm__("push %0\n\tpopfl\n\t": :"r" (x))

#define clts() \
		__asm__("movl %cr3, %eax\n\tmovl %eax, %cr3\n\t")

#define KERNEL_OFFSET 0x00000000

#define MASTER_PIC_BASE_VECTOR	0x40
#define SLAVE_PIC_BASE_VECTOR	0x48
#define IRQ16_BASE_VECTOR		0

#endif  // #ifndef __HOST_BEOS_H__
