/*
 *  FreeMWare: run multiple x86 operating systems concurrently
 *  Copyright (C) 1999  Kevin P. Lawton
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

#ifndef __PAGING_H__
#define __PAGING_H__

// Page Directory/Table format
typedef struct {
    u8   P:1;
    u8   RW:1;
    u8   US:1;
    u8   PWT:1;
    u8   PCD:1;
    u8   A:1;
    u8   D:1;
    u8   PS:1;
    u8   G:1;
    u8   avail:3;
    u32  base:20;
} __attribute__ ((packed)) pageEntry_t;

#endif  // __PAGING_H__
