:
# SCCSID(@(#)postinst.sh	1.9) Modified 10:33:35 12/10/99

### Copyright (c) 1994-1999 TreLOS, Inc.
### All rights reserved.
### This is an unpublished work containing CONFIDENTIAL INFORMATION
### that is the property of TreLOS, Inc.
### Any unauthorized use, duplication or disclosure is prohibited.

#########################################################################
#									#
# 	Merge X Clients Package "postinstall" script.			#
#									#
# --------------------------------------------------------------------- #
#									#
#	Run the scripts that:						#
#		1: Install the fonts.					#
#		2: Install the icon files.				#
#		3: Install "misc" stuff.				#
#									#
#########################################################################
#
#	This script is called by the top level Merge Remove script.
#	With Custom+, the top level remove script is "ccs.sh".
#	With pkgadd, the top level remove script is "prerem_pa.sh".
#
#########################################################################

#########################################################################
#
#	This script *must* be called with STATICMERGE and VARMERGE set.
#
#########################################################################

EXIT_NORMAL=0		# Normal exit value
EXIT_FAIL=1		# Failure exit value

if [ "x$STATICMERGE" = "x" -o "x$VARMERGE" = "x" ]
then
	# This should never happen.
	echo STATICMERGE or VARMERGE not set.
	echo Cannot continue install.
	exit $EXIT_FAIL
fi
if [ ! -f $STATICMERGE/bin/s_init.sh ]
then
	# This should never happen.
	echo Missing $STATICMERGE/bin/s_init.sh
	echo Cannot continue install.
	exit $EXIT_FAIL
fi
. $STATICMERGE/bin/s_init.sh
# "s_init.sh" set up variables and functions used by this script.
# (such as NULL, LOG_FILE, usrMsg, and everything from the Version file.)


#############################################################################
#        Install X related stuff.
#############################################################################

[ -f $STATICMERGE/xc/install/inst_font.sh ] && \
  sh $STATICMERGE/xc/install/inst_font.sh install

[ -f $STATICMERGE/xc/install/inst_icon.sh ] && \
  sh $STATICMERGE/xc/install/inst_icon.sh install

[ -f $STATICMERGE/xc/install/inst_help.sh ] && \
  sh $STATICMERGE/xc/install/inst_help.sh install

[ -f $STATICMERGE/xc/install/inst_misc.sh ] && \
  sh $STATICMERGE/xc/install/inst_misc.sh install

exit $EXIT_NORMAL
