#!/bin/sh
# SCCSID(@(#)ask_eula.sh	1.2) Modified 19:08:36 1/10/00
# This script is for Win4Lin on Linux systems.
# Present the End User License Agreement (EULA) to the user
# and ask them to agree to it.
# This script exits with:
#    0 when the user agrees
#    1 when the user does not agree
#    2 when something bad happens
# When the user agrees, the $VARMERGE/agree.txt file is created with
# a text line that says that the user agreed.

rm -f $VARMERGE/agree.txt

EOPT="-e"
Echo()
{
	echo $EOPT $*
}

Get_YN()
{
	QYN="$1"
	while true
	do
		Echo "$QYN? (y/n) \c"
		read ANS
		case $ANS in
		y|Y|yes|YES|Yes)
			ANS=y
			break
			;;
		n|N|no|NO|No)
			ANS=n
			break
			;;
		*)
			Echo "Please answer y for Yes or n or No"
			;;
		esac
	done
}

if [ -z "$STATICMERGE" ]
then
	STATICMERGE=/opt/win4lin
	export STATICMERGE
fi
EULA="$STATICMERGE/license.txt"
if [ ! -f "$EULA" -o -L "$EULA" ]
then
	Echo "Error, $EULA does not exist!"
	Echo "Cannot complete installation of Win4Lin."
	Echo "Please remove the Win4Lin package."
	Echo "(The command 'rpm -e Win4Lin' removes the package.)"
	Echo
	Echo "Press return to continue"
	read ANS
	exit 2
fi

cat $EULA
Echo
Echo "(A copy of the above license can be found in the file $EULA)"
Echo
Echo "You must agree to the terms of this license \c"
Echo " before using the Win4Lin software."
Echo

Get_YN "Do you agree to the terms of this license"

if [ "$ANS" = "y" ]
then
	rm -f $VARMERGE/agree.txt
	echo "The user agreed to the End User License Agreement" \
		> $VARMERGE/agree.txt
	date >>   $VARMERGE/agree.txt
	exit 0
fi

Echo
Echo "You must agree to the license before using this software."
Echo "You must remove the Win4Lin package now."
Echo "(If you installed this using 'rpm', then the command 'rpm -e Win4Lin'"
Echo "removes the package.)"
Echo
Echo "Press return to continue"
read ANS

exit 1
