:
# SCCSID(@(#)s_init.sh	1.9) Modified 22:42:28 7/7/99

### Copyright (c) 1994-1999 TreLOS, Inc.
### All rights reserved.
### This is an unpublished work containing CONFIDENTIAL INFORMATION
### that is the property of TreLOS, Inc.
### Any unauthorized use, duplication or disclosure is prohibited.

# Set up common functions and variables needed by install and remove scripts.
# This script must be "sourced in" so the variable and functions will
# be available.

# STATICMERGE and VARMERGE must already be set!

# Make sure NULL and LOG_FILE are set.  (They are expected to be set,
# but just to be safe, make sure they are set to something reasonable.)

if [ "x$LOG_FILE" = "x" -o "x$NULL" = "x" ]
then
	LOGDIR=${LOGDIR:-$VARMERGE/log}
	[ ! -d $LOGDIR ] && mkdir -p $LOGDIR
	[ -z "$LOG_FILE" ] && LOG_FILE=$LOGDIR/script.log

	if [ -z "$NULL" ]
	then
		# Note:  MERGETRACE is defined or not in the calling script.
		if [ -z "$MERGETRACE" ]
		then
			NULL=/dev/null
		else
			NULL=$LOGDIR/script.nul
			rm -rf $NULL
		fi
	fi
	export LOG_FILE NULL
fi
if [ "x$CCS_LOG" = "xccs_log" ]
then
	. ccsSetup.sh
fi
. $STATICMERGE/set_nls.sh
. $STATICMERGE/Version

# Make sure valid INSTALLTYPE and SYSTEMTYPE.  These should *never*
# be invalid, but the test here is to catch problems when Merge is
# ported to new systems.
case $INSTALLTYPE in
rpm) ;;
custom+) ;;
pkgadd)	;;
*)	 echo "ERROR: Invalid install type from Version file: $INSTALLTYPE" \
		| tee -a $LOG_FILE
	exit $EXIT_FAIL
	;;
esac
# The prefered settings are "sco32" and "uw7".  (We are transitioning
# to these from "sco" and "gemini".)
case $SYSTEMTYPE in
linux)	;;
sco32)	;;
uw7)	;;
sco)	;;
gemini)	;;
*)	echo "ERROR: Invalid system type from Version file: $SYSTEMTYPE" \
		| tee -a $LOG_FILE
	exit $EXIT_FAIL
	;;
esac

