:
# SCCSID(@(#)upgrade_s_fonts.sh	1.5) Modified 01:26:20 12/3/99
####################################################################
#
# Update the autoexec.bat to have "attrib +s c:\windows\fonts".
#

NULL=/dev/null

# "Global" variables that are shared between the functions:
PLETTER=
PDIR=
WINDIR=
TRACE=
BS="\\\\"
DO_SILENT=silent
OK_TO_LOG=no

# Get the VARMERGE and STATICMERGE settings (and others too)
. /etc/mrgssv.sh
if [ "z$LOGFILE" != "z" ]
then
	OK_TO_LOG="ok_to_log"
else
	LOGFILE=/dev/null
fi

EE()
{
	if [ "$SYSTEMTYPE" = "linux" ]
	then
		echo -e $*
	else
		echo $*
}

#
# Log a message
#
Log()
{
	[ "$OK_TO_LOG" = "ok_to_log" ] && echo $* >> $LOGFILE
	[ "x$TRACE" = "xtrace" ]       && echo $*
}

#
# Echo and Log a message if not in silent mode
#
Echo()
{
	[ "$OK_TO_LOG" = "ok_to_log" ] && echo $* >> $LOGFILE
	[ "$DO_SILENT" = "notsilent" ] && echo $*
}

#
# Common exit code
#
Exit()
{
	STATUS=$1
	exit $STATUS
}

#
# Determine the "Personal Drive Letter" and where it is located
# from the configuration info.
# Put this info in the variables PLETTER and PDIR.
#
Determine_Config_Settings()
{
	Log Determine_Config_Settings

	# The fuctions get_personal_drive_letter and get_drive_root
	# are in the file unixdrive.sh.
	. $STATICMERGE/bin/unixdrives.sh

	get_personal_drive_letter $1
	PLETTER=$PERS_DRV_LETTER
	get_drive_root $PLETTER $1
	if [ $? -ne 0 ]
	then
		Echo "Error 10: The personal drive directory in the $1"
		Echo "configuration is not valid."
		Echo "Cannot continue.  Exiting..."
		Exit 10
	fi
	PDIR=$DRV_ROOT
	WINDIR=`winconfig $1 list windowsdir | cut -d= -f2`

	Log Personal drive letter = $PLETTER
	Log Personal drive rooted at $PDIR
	Log Windows dir = $WINDIR

	if [ ! -d $PDIR ]
	then
		Echo "Error 19: The personal drive directory $PDIR"
		Echo "does not exist, and could not be created."
		Echo "Cannot continue.  Exiting..."
		Exit 19

	fi
	if [ ! -d $PDIR/$WINDIR ]
	then
		Echo "Error 19: The windows directory $PDIR/WINDIR"
		Echo "does not exist, and could not be created."
		Echo "Cannot continue.  Exiting..."
		Exit 19

	fi
}

#
# Function to add the "system" attribute to the Windows "fonts"
# directory.  This is done with an "attrib" command in autoexec.bat.
# (The autoexec.bat used is the "personal" one.)
#
Do_Update()
{
	AE_BAT="$PDIR/autoexec.bat"
	if [ -f $AE_BAT ]
	then
		BS="\\\\"
		grep -i 'attrib' $AE_BAT | grep -i fonts > $NULL 2> $NULL
		if [ $? -ne 0 ]
		then
			# Add the line to autoexec.bat
			EE "@attrib +s $PLETTER:${BS}$WINDIR${BS}fonts
"  \
				>> $AE_BAT
		fi
	fi
}

#
# Exit cleanly if user interrupts use
#
interruptProc()
{
	Echo "upgrade cancelled by the user."

	Exit 6
}

####################################################
# End of function declarations.  Start of MAIN code.
# Main
####################################################
trap interruptProc 1 2 3 15
if [ "x$1" = "x" ]
then
    WIN_CONFIG="win"
else
    WIN_CONFIG=$1
fi

Determine_Config_Settings $WIN_CONFIG
Do_Update
Exit 0
