#!/bin/sh
# SCCSID(@(#)user_floppy.sh	1.9) Modified 16:35:03 12/17/99
# This script is used in the last-ditch effort to get a boot floppy
# so that loading of Windows/DOS from the Win9x CD can continue.
# It is intended to only be called from "loadwindows".
. /etc/mrgssv.sh

BFLOP=$VARMERGE/bootflop.dsk
DDCMD=/bin/dd
MERGE_CD_DEV_NAME=$1
DOS7DBR="$STATICMERGE/bs/dos7.dbr"

if [ -f $BFLOP -o -L $BFLOP ]
then
	# Should not have been called when this file exists.
	exit 0
fi

if [ "$SYSTEMTYPE" = "linux" ]
then
	EOPT="-e"
else
	EOPT=
fi

Echo()
{
	echo $EOPT $*
}

Get_YN()
{
	QYN="$1"
	while true
	do
		Echo "$QYN? (y/n/q)\c"
		read ANS
		case $ANS in
		y|Y)
			ANS=y
			break
			;;
		n|N)
			ANS=n
			break
			;;
		q|Q|0)
			ANS=q
			break
			;;
		*)
			Echo "Plese answer y or n or q"
			;;
		esac
	done
}

Enter_filename()
{
	QF="$1"
	while true
	do
		Echo "$QF \c"
		read FNAME
		if [ "x$FNAME" != "x" ]
		then
			if [ -f "$FNAME" -o -L "$FNAME" ]
			then
				Get_YN "Is $FNAME correct"
				[ "$ANS" = "q" ] && exit 1
				[ "$ANS" = "y" ] && break
			fi
		fi
		Echo "That filename is not useable."
		Get_YN "Try again"
		[ "$ANS" = "y" ] && continue
		exit 1
	done
}

NotBootFlop()
{
		Echo "This does not appear to be a boot floppy."
		Echo "Cannot continue"
		# mv $BFLOP $VARMERGE/tmp
		rm -f $BFLOP  2> /dev/null
		exit 1
}

ClearFloppyImage()
{
	echo dir | $STATICMERGE/dosdisk -s $BFLOP > $TMPFILE
	grep command.com $TMPFILE > /dev/null
	if [ $? -ne 0 ]
	then
		return 1
	fi
	for i in `cat $TMPFILE`
	do
		case $i in
		command.com|io.sys|winboot.sys|msdos.sys|format.com|sys.com)
			continue
			;;
		esac
		echo delete $i | $STATICMERGE/dosdisk -s $BFLOP
	done
	return 0
}

touch $BFLOP 2> /dev/null
if [ ! -f $BFLOP ]
then
	Echo Cannot create $BFLOP
	exit 1
fi

TMPFILE=$VARMERGE/tmp/user_flop

# Lets see if we can extract a boot floopy from a bootable CD ROM
$STATICMERGE/bin/torito -i $MERGE_CD_DEV_NAME -o $TMPFILE
RETVAL=$?
if [ $RETVAL -eq 0 ]
then
	Echo "Found bootable CD-ROM. Extracting boot image ..."
	$DDCMD if=$DOS7DBR of=$BFLOP 2>/dev/null
	$DDCMD if=$TMPFILE of=$BFLOP bs=512 skip=1 seek=1  2>/dev/null
	rm $TMPFILE
	ClearFloppyImage && exit 0
fi
# Could not get floppy image from CD: prompt user for floppy

Echo
Echo
Echo "A Windows boot floppy is needed to complete the load of"
Echo "of Windows from the Windows CD."
Echo
sleep 2
Echo "The Windows boot floppy must match the version of Windows"
Echo "you are loading."
Echo "You can use a real floppy or image file of such a floppy."
Echo
sleep 2
Echo
Get_YN "Do you have an appropriate real Windows boot floppy now "
[ "$ANS" = "q" ] && exit 1
if [ "$ANS" = "n" ]
then
	Get_YN "Do you have an appropriate image file now "
	if [ "$ANS" = "n" ]
	then
		Echo "Cannot continue the load."
		exit 1
	fi
	Enter_filename "Enter the filename of the boot floppy image:"
	cp $FNAME $BFLOP
else
	# Make an image of the file
	if [ "$SYSTEMTYPE" = "linux" ]
	then
		FLOP=/dev/fd0
	elif [ "$SYSTEMTYPE" = "sco32" ]
	then
		FLOP=/dev/rfd0
	elif [ "$SYSTEMTYPE" = "uw7" ]
	then
		FLOP=/dev/rdsk/f0t
	fi
	while true
	do
		Echo ""
		Echo "Insert the floppy in the drive and then press return \c"
		read ANS
		Echo ""
		Echo "Reading the floppy."
		dd if=$FLOP of=$BFLOP
		if [ $? -ne 0 ]
		then
			Echo "Failed to acces the floppy"
			Get_YN "Try again"
			[ "$ANS" = "y" ] && continue
			exit 1
		fi
		Echo ""
		Echo "You may now remove the floppy from the drive."
		Echo ""
		break
	done
fi

# At this point we have a file that is supposed to be an appropriate
# DOS 7.x boot floppy.  Clear out all the files we don't need.


ClearFloppyImage || NotBootFlop

# All done
exit 0
