#! /bin/sh
# SCCSID(@(#)xedit_file.sh	1.1) Modified 17:27:00 12/20/99
# Edit a file with an X based editor.
#
# The first parameter is the file to edit.
# The second optional parameter is a pretty name or title for
# what is being edited, if the editor frame has a capability
# of putting a title on the window.
# (This can be useful, because often what is actually being edited
# can be a temporary file, and the real file might only get
# updated when the GUI chooses to "save" the change.)
# But to use this option this script has to know what option to use.

. /etc/mrgssv.sh

XTERM=/usr/bin/X11/xterm
[ ! -x $XTERM ] && XTERM=xterm

FILE_NAME="$1"
FILE_TITLE="$2"
if [ "x$FILE_NAME" = "x" ]
then
	exit 1
fi
if [ "x$FILE_TITLE" = "x" ]
then
	FILE_TITLE="$FILE_NAME"
fi

DEFAULTMERGE=/etc/default/merge
if [ "x$MERGE_X_EDITOR" = "x" ]
then
	# Look for default in /etc/default/merge
	eval `grep "^MERGE_X_EDITOR=" $DEFAULTMERGE`
	eval `grep "^MERGE_X_EDIT_OPT=" $DEFAULTMERGE`
fi
if [ "x$MERGE_X_EDIT_OPT" = "x" ]
then
	OPT1=""
	OPT2=""
else
	OPT1="$MERGE_X_EDIT_OPT"
	OPT2="$FILE_TITLE"
fi

if [ "x$MERGE_X_EDITOR" != "x" ]
then
	if [ -x "$MERGE_X_EDITOR" ]
	then
		"$MERGE_X_EDITOR" "$FILE_NAME" "$OPT1" "$OPT2"
		exit 0
	fi
	FILE=$HOME/err$$.txt
	rm -f $FILE
	echo "echo #! /bin/sh"					>  $FILE
	echo "echo Cannot edit the file."			>> $FILE
	echo "echo Editor specified by MERGE_X_EDITOR:"		>> $FILE
	echo "echo ' ' $MERGE_X_EDITOR"				>> $FILE
	echo "echo does not exist or is not executable."	>> $FILE
	echo "echo "						>> $FILE
	echo "echo Press return to continue"			>> $FILE
	echo "read FOO"						>> $FILE
	echo "exit 0"						>> $FILE
	chmod +x $FILE
	$XTERM -T Error -e $FILE
	rm -f $FILE
	exit 0
fi

# Look around for a known X editor.
MERGE_X_EDITOR=/usr/bin/kedit
if [ -x $MERGE_X_EDITOR ]
then
	"$MERGE_X_EDITOR" "$FILE_NAME"
	exit 0
fi
MERGE_X_EDITOR=/opt/kde/bin/kedit
if [ -x $MERGE_X_EDITOR ]
then
	"$MERGE_X_EDITOR" "$FILE_NAME"
	exit 0
fi

FILE=$HOME/err$$.txt
rm -f $FILE
echo "echo #! /bin/sh"						>  $FILE
echo "echo Cannot edit the file."				>> $FILE
echo "echo Editor not specified by MERGE_X_EDITOR,"		>> $FILE
echo "echo '('or default in $DEFAULTMERGE')',"			>> $FILE
echo "echo and could not find a standard X file editor."	>> $FILE
echo "echo "							>> $FILE
echo "echo Press return to continue"				>> $FILE
echo "read FOO"							>> $FILE
echo "exit 0"							>> $FILE
chmod +x $FILE

$XTERM -T Error -e $FILE

rm -f $FILE
exit 0
