#!/bin/sh
# SCCSID(@(#)mknode_linux.sh	1.1) Modified 17:22:08 6/29/99
# Create all the Win4Lin drivers device nodes.
# All of these go under $VARMERGE/mrgdev

# Get the VARMERGE and STATICMERGE settings
. /etc/mrgssv.sh

# Look up major device numbers in /proc/devices
while read -r MJ DEVNAME
do
	case $DEVNAME in
	Merge) MERGE_MJ=$MJ
		;;
	vdsp)  VDSP_MJ=$MJ
		;;
	vgic)  VGIC_MJ=$MJ
		;;
	vmouse) VMOUSE_MJ=$MJ
		;;
	vkbd) VKBD_MJ=$MJ
		;;
	Mpip) MPIP_MJ=$MJ 
		;;
	vwdisp) VW_MJ=$MJ
		;;
	*);;
	esac

done < /proc/devices

if [ ! -d $VARMERGE/mrgdev ]
then
	mkdir      $VARMERGE/mrgdev
	chown root $VARMERGE/mrgdev
	chgrp root $VARMERGE/mrgdev
fi
if [ ! -d $VARMERGE/mrgdev/vpi ]
then
	mkdir      $VARMERGE/mrgdev/vpi
	chown root $VARMERGE/mrgdev/vpi
	chgrp root $VARMERGE/mrgdev/vpi
fi
# Make the device subdirectories that Merge needs.
for i in mrgsys vems vdsp vkbd
do
	if [ ! -d $VARMERGE/mrgdev/$i ]
	then
		mkdir $VARMERGE/mrgdev/$i
	fi
done
for i in vmouse
do
	if [ ! -d $VARMERGE/mrgdev/vpi/$i ]
	then
		mkdir $VARMERGE/mrgdev/vpi/$i
	fi
done

# Make all the Device Nodes
while read -r DEV NODE TYPE MN
do
	# Get the right major number for the device
	case $DEV in
	merge) MAJOR=$MERGE_MJ
		;;
	vdsp)  MAJOR=$VDSP_MJ
		;;
	vgic)  MAJOR=$VGIC_MJ
		;;
	vmouse) MAJOR=$VMOUSE_MJ
		;;
	vkbd)  MAJOR=$VKBD_MJ
		;;
	mpip)  MAJOR=$MPIP_MJ
		;;
	vw)    MAJOR=$VW_MJ
		;;
	*);;
	esac

	if [ ! -c $VARMERGE/mrgdev/$NODE ]
	then
		mknod -m 666 $VARMERGE/mrgdev/$NODE $TYPE $MAJOR $MN
		# echo making node $VARMERGE/mrgdev/$NODE
	fi
done < $STATICMERGE/drivers/tools/nodes_linux.txt
