:
# SCCSID(@(#)find_inst_dir.sh	1.4) Modified 01:26:17 12/3/99
# Search for directories that we can install DOS 7.x or Windows 9x from.
# There can be more than one!
# The first parameter is where to start looking, and where to relatively
# reports the found directores.
# The second paramater is the file to write the list of found files to.
# It should be a full path filename or relative to the directory
# specified in the first parameter.
THE_TOP=$1
OUTFILE=$2
if [ "x$2" = "x" ]
then
	echo Invalid input
	echo First param is where to search, the second is the output filename.
	exit 1
fi
if [ ! -d $THE_TOP ]
then
	echo Error, parameter 1 is not a directory: $THE_TOP
	exit 2
fi

TMPDIR=$HOME
FOUND_LIST=$TMPDIR/fid.find.$$.out
EX_LIST_FILES=$TMPDIR/fid.ex.$$.f
EX_LIST_DIRS=$TMPDIR/fid.ex.$$.d
CAB_LIST_FILES=$TMPDIR/fid.cab.$$.f
CAB_LIST_DIRS=$TMPDIR/fid.cab.$$.d

Exit_Clean()
{
	rm -f $FOUND_LIST
	rm -f $EX_LIST_FILES
	rm -f $EX_LIST_DIRS
	rm -f $CAB_LIST_FILES
	rm -f $CAB_LIST_DIRS
	exit $1
}

Trap()
{
	trap 1 2 3 15
	Exit_Clean 9
}
trap Trap 1 2 3 15

cd $THE_TOP
touch $OUTFILE
if [ ! -f $OUTFILE ]
then
	echo Error, cannot create output file $OUTFILE
	exit 3
fi
> $OUTFILE

find . \( -name extract.exe -o -name EXTRACT.EXE \
       -o -name win95\*.cab -o -name WIN95\*.CAB \
       -o -name win98\*.cab -o -name WIN98\*.CAB \
	\) -print >  $FOUND_LIST
if [ ! -s $FOUND_LIST ]
then
	# The find failed.  Either the CD is the wrong CD, not mounted
	# properly, or it is one of those CDs that has an invalid
	# directory structure that causes find to fail.
	# Just in case of the latter, use alternate means to try to locate
	# the directory.
	ls       ./win95_04.cab       ./WIN95_04.CAB >  $FOUND_LIST 2>/dev/null
	ls     ./*/win95_04.cab     ./*/WIN95_04.CAB >> $FOUND_LIST 2>/dev/null
	ls   ./*/*/win95_04.cab   ./*/*/WIN95_04.CAB >> $FOUND_LIST 2>/dev/null
	ls ./*/*/*/win95_04.cab ./*/*/*/WIN95_04.CAB >> $FOUND_LIST 2>/dev/null
	ls       ./win98_22.cab       ./WIN98_22.CAB >> $FOUND_LIST 2>/dev/null
	ls     ./*/win98_22.cab     ./*/WIN98_22.CAB >> $FOUND_LIST 2>/dev/null
	ls   ./*/*/win98_22.cab   ./*/*/WIN98_22.CAB >> $FOUND_LIST 2>/dev/null
	ls ./*/*/*/win98_22.cab ./*/*/*/WIN98_22.CAB >> $FOUND_LIST 2>/dev/null
	ls       ./extract.exe        ./EXTRACT.EXE  >> $FOUND_LIST 2>/dev/null
	ls     ./*/extract.exe      ./*/EXTRACT.EXE  >> $FOUND_LIST 2>/dev/null
	ls   ./*/*/extract.exe    ./*/*/EXTRACT.EXE  >> $FOUND_LIST 2>/dev/null
	ls ./*/*/*/extract.exe  ./*/*/*/EXTRACT.EXE  >> $FOUND_LIST 2>/dev/null
fi
if [ ! -s $FOUND_LIST ]
then
	echo Nothing found
	Exit_Clean 4
fi
grep -i extract $FOUND_LIST | sort | uniq > $EX_LIST_FILES
grep -i cab     $FOUND_LIST | sort | uniq > $CAB_LIST_FILES

for ii in `cat $EX_LIST_FILES`
do
	d=`dirname $ii`
	echo $d
done | sort | uniq > $EX_LIST_DIRS

for ii in `cat $CAB_LIST_FILES`
do
	d=`dirname $ii`
	echo $d
done | sort | uniq > $CAB_LIST_DIRS

for ii in `cat $CAB_LIST_DIRS`
do
	n=`grep -x $ii $EX_LIST_DIRS`
	if [ -n "$n" ]
	then
		echo $n
	fi
done | sort | uniq > $OUTFILE

Exit_Clean 0
