:
# SCCSID(@(#)instdx_suidr.sh	1.6) Modified 21:27:00 7/5/99
########################################################################
#
#	Copyright (c) 1993-1999 TreLOS, Inc.
#	All rights reserved.
#	This is an unpublished work containing CONFIDENTIAL INFORMATION
#	that is the property of TreLOS, Inc.
#	Any unauthorized use, duplication or disclosure is prohibited.
#
########################################################################
#
# This script is run during Merge installation to set the correct
# ownership and modes on the file /usr/bin/dos.
#
# This script can be used by the system administrator to fix the
# ownership and mode of /usr/bin/dos, and fix the link of
# /usr/bin/win to /usr/bin/dos.

# Get the setting of DOSWINBINDIR, and STATICMERGE.
. /etc/mrgssv.sh

if [ ! -f $DOSWINBINDIR/dos -a ! -L $DOSWINBINDIR/dos ]
then
	echo "Error: Missing file $DOSWINBINDIR/dos"
	exit 1
fi

# Make it "setuid root".
chown root $DOSWINBINDIR/dos >> /dev/null 2>&1
if [ $? -ne 0 ]
then
	echo No permission to install $DOSWINBINDIR/dos
	exit 1
fi
chgrp bin  $DOSWINBINDIR/dos
chmod 4555 $DOSWINBINDIR/dos

# Normally the link of $DOSWINBINDIR/dos to $DOSWINBINDIR/win is ok.
# The following code attempts to repair an invalid or broken link.
if [ -f $DOSWINBINDIR/win -o -L $DOSWINBINDIR/win ]
then
	cmp -s $DOSWINBINDIR/dos $DOSWINBINDIR/win 2>> /dev/null
	if [ $? -ne 0 ]
	then
		rm -f $DOSWINBINDIR/win
		if [ -L $DOSWINBINDIR/dos ]
		then
			ln -s $DOSWINBINDIR/dos $DOSWINBINDIR/win 2>> /dev/null
		else
			ln    $DOSWINBINDIR/dos $DOSWINBINDIR/win 2>> /dev/null
		fi
	fi
else
	if [ -L $DOSWINBINDIR/dos ]
	then
		ln -s $DOSWINBINDIR/dos $DOSWINBINDIR/win 2>> /dev/null
	else
		ln    $DOSWINBINDIR/dos $DOSWINBINDIR/win 2>> /dev/null
	fi
fi

# mcd needs to be set uid to root
# The following code sets it that way.
if [ -f $STATICMERGE/mcd ]
then
	chgrp bin $STATICMERGE/mcd
	chown root $STATICMERGE/mcd
	chmod 4555 $STATICMERGE/mcd
fi

# dos7utils needs to be set uid to root
# The following code sets it that way.
if [ -f $STATICMERGE/dos7utils ]
then
	chgrp bin $STATICMERGE/dos7utils
	chown root $STATICMERGE/dos7utils
	chmod 4555 $STATICMERGE/dos7utils
fi

exit 0
