:
# SCCSID(@(#)remove_rpm.sh	1.4) Modified 15:51:40 8/18/99
### Copyright (c) 1999 TreLOS, Inc.
###############################################################################
#
#	RPM "pre-remove" script for Lin4Win
#
###############################################################################

PATH=/bin:/usr/bin:$ROOT/usr/bin:$PATH; export PATH

if [ -f /etc/mrgssv.sh ]
then
	SSV_OPTION=noexit
	. /etc/mrgssv.sh
	if [ "$FAIL_SSV" != "allok" ]
	then
		# mrgssv.sh guessed at the STATICMERGE and VARMERGE settings,
		# so we want to save the log files so that perhaps
		# someone can look at them to diagnose the problem.
		SAVELOG=save_the_log
	else
		if [ ! -d $VARMERGE ]
		then
			echo "WARNING: Missing directory $VARMERGE"
			echo "Remove may not be complete."
			SAVELOG=save_the_log
		fi
		if [ ! -d $STATICMERGE ]
		then
			echo "WARNING: Missing directory $STATICMERGE"
			echo "Remove may not be complete."
			SAVELOG=save_the_log
		fi
	fi
else
	# Code here is duplicated from mrgssv.sh
		if [ -d /opt/win4lin ]
		then
			STATICMERGE=/opt/win4lin
		elif [ -d /opt/merge ]
		then
			STATICMERGE=/opt/merge
		else
			STATICMERGE=/usr/lib/merge
		fi
		if [ -d /var/win4lin ]
		then
			VARMERGE=/var/win4lin
		elif [ -d /var/merge ]
		then
			VARMERGE=/var/merge
		else
			VARMERGE=/usr/merge
		fi
	echo "STATICMERGE=$STATICMERGE" > /etc/mrgssv.sh
	echo "VARMERGE=$VARMERGE" >> /etc/mrgssv.sh
	echo "DOSWINBINDIR=/bin" >> /etc/mrgssv.sh
	SAVELOG=save_the_log
fi

# See if there is a developer's debug variables file.
if [ -f $VARMERGE/dbg_vars.sh ]
then
	. $VARMERGE/dbg_vars.sh
fi

LOGDIR=${LOGDIR:-$VARMERGE/log}
if [ -z "$MERGETRACE" ]
then
	NULL=/dev/null
else
	NULL=$LOGDIR/inst.nul
	[ -f $NULL ] && rm -rf $NULL
fi

[ ! -d $LOGDIR ] && mkdir -p $LOGDIR
chmod 775 $LOGDIR
chown bin $LOGDIR
chgrp bin $LOGDIR
if [ -z "$LOG_FILE" ]
then
	LOG_FILE=$LOGDIR/rem.log
	rm -rf $LOG_FILE
	> $LOG_FILE
fi

#------------------------------------------
# The script "set_nls.sh" uses STATICMERGE to set MFILE.
if [ -f $STATICMERGE/set_nls.sh ]
then
	. $STATICMERGE/set_nls.sh
	USRMSG=usrMsg
else
	USRMSG="echo -e"
fi

# DM is the domain for messages for this script.
DM="LCC.MERGE.UNIX.INSTALL"

export LOGDIR LOGTYPE NULL LOG_FILE
export MFILE DM

# The Version file sets: MERGENAME= INSTALLTYPE= SYSTEMTYPE= UNIX_REL=
if [ -f $STATICMERGE/Version ]
then
	. $STATICMERGE/Version
else
	if [ -f $VARMERGE/Version ]
	then
		. $VARMERGE/Version
	else
		# This should never happen unless the install failed
		# to complete.
		# We want to go ahead an try to do the remove.  So print out
		# a warning and try to continue on.
		SAVELOG=save_the_log

		# This error message needs to be NLSized.
		echo "WARNING: Cannot find Version file" | tee -a $LOG_FILE
		echo "May not be able to complete the remove" | tee -a $LOG_FILE
		echo "" | tee -a $LOG_FILE

		# Fake up some setting that are set in the Version file.
		MERGENAME=Win4Lin
		INSTALLTYPE=rpm
		SYSTEMTYPE=linux
		UNIX_REL=2
	fi
fi

# LINUX_TBD_RPM_REMOVAL: Add code to do the following:
#	1: Do the Merge ioctl to prevent new sessions from starting.
#	2: Do a Merge ioctl to see if there are any current Merge sessions
#	   running.  If so, then:
#		A: Print a message to that effect.
#		B: Send sigterm to all the Win4Lin sessions.
# 	3: No sessions are running and new ones cannot start up, so
#	   now it is safe to run unloadem and then the individual
#	   remove scripts.

[ -x $STATICMERGE/drivers/tools/unloadem ] && \
     $STATICMERGE/drivers/tools/unloadem

Remove_Default_Set()
{
	# Remove the default.set file if it is likely the one that we
	# created in the postininstall script.

	VAR_DOSI=$VARMERGE/dosi
	STAT_DOSI=$STATICMERGE/dosi
	[ ! -h $VAR_DOSI/default.set -a ! -f $VAR_DOSI/default.set ] && return
	
	for i in $STAT_DOSI/[123456789]*.set
	do
		cmp -s $i $VAR_DOSI/default.set
		if [ $? -eq 0 ]
		then
			# The are the same, so we delete the default.set file.
			rm -f $VAR_DOSI/default.set
			rmdir $VAR_DOSI > /dev/null 2>&1
			break
		fi
	done
	return
}
Remove_Default_Set

RETVAL=0
if [ -d $STATICMERGE/Remove ]
then
	for SCRIPT in $STATICMERGE/Remove/*.sh
	do
		if [ -r $SCRIPT ]
		then
			echo "$SCRIPT"  >> $LOG_FILE
			echo "--------" >> $LOG_FILE
			sh $SCRIPT      >> $LOG_FILE 2>&1
			if [ $? -ne 0 ]
			then
				RETVAL=$?
				echo "RETVAL=$RETVAL" >> $LOG_FILE
			fi
			echo "--------" >> $LOG_FILE
		fi
	done
fi

# Remove logfile if no errors and the $SAVELOG is not set.
if [ $RETVAL -eq 0 -a "x$SAVELOG" = "x" ]
then
	rm -f $LOG_FILE
	rmdir $LOGDIR > /dev/null 2>&1
fi

# Removed the symbolic links:
[ -L /usr/lib/merge ] && rm -f /usr/lib/merge
[ -L /usr/merge ]     && rm -f /usr/merge

exit 0
