:
# SCCSID(@(#)inst_misc.sh	1.20) Modified 17:59:56 10/4/99

### Copyright (c) 1988-1999 TreLOS, Inc.
### All rights reserved.
### This is an unpublished work containing CONFIDENTIAL INFORMATION
### that is the property of TreLOS, Inc.
### Any unauthorized use, duplication or disclosure is prohibited.

#########################################################################
#									#
#	Merge X Clients Package MISC installation/removal script.	#
# --------------------------------------------------------------------- #
#									#
#	Always exits with 0						#
#									#
#	For installation no parameter is needed.			#
#	For removal the parameter is "remove".				#
#									#
#########################################################################

reschedule()
{
	if [ "$INST_OR_REM" = "$REMOVE_OPTION" ]
	then
		rm -f $SS_DIR/inst_misc.sh
		rmdir $SS_DIR > /dev/null 2>&1
		exit $1
	fi
	if [ ! -d $SS_DIR ]
	then
		mkdir $SS_DIR
		chown bin $SS_DIR
		chgrp bin $SS_DIR
		chmod 755 $SS_DIR
	fi
	echo :  > $SS_DIR/inst_misc.sh
	echo "sh $STATICMERGE/xc/install/inst_misc.sh install" \
	       >> $SS_DIR/inst_misc.sh
	chmod 555 $SS_DIR/inst_misc.sh
	chgrp bin $SS_DIR/inst_misc.sh
	chown bin $SS_DIR/inst_misc.sh
}

Fix_Xterm()
{
    # Some X-Servers come with an "xterm" terminfo which has bad
    # information which screws up xcrt. We must Remove these bogus
    # entries from the xterm terminfo.  If we cannot save the old one,
    # then don't make the changes.
    TI_DIR=/usr/lib/terminfo/x
    if [ ! -d $TI_DIR ]
    then
	TI_DIR=/usr/share/lib/terminfo/x
	if [ ! -d $TI_DIR ]
	then
		echo "Can't find terminfo directory for xterm.ti" >> $LOG_FILE
		echo "Returning..." >> $LOG_FILE
		return
	fi
    fi
    TI_FILE=$TI_DIR/old.xterm.ti
    if [ -f $TI_FILE ]
    then
	return
    fi
    touch ${TI_FILE}ZZ >> $LOG_FILE 2>&1
    if [ ! -f $TI_FILE -a -f ${TI_FILE}ZZ ]
    then
	rm -f ${TI_FILE}ZZ
	infocmp -1 xterm > $TI_FILE 2>> $LOG_FILE
	if [ $? -eq 0 ]
	then
		cat $TI_FILE | grep -v rmpch= | grep -v smsc > $TDIR/newxt$$
		cmp -s $TI_FILE $TDIR/newxt$$
		if [ $? -ne 0 ]
		then
			# There is a difference, so use "tic" to compile
			# the new terminfo file that has the bogus
			# rmpch and or smsc lines removed.  Leave the old
			# version of the file.
			tic $TDIR/newxt$$
		else
			# No difference, so clean up.
			rm -f $TI_FILE
		fi
		rm -f $TDIR/newxt$$
	fi
    fi
    rm -f ${TI_FILE}ZZ
}


Install_Misc()
{
	Fix_Xterm

	if [ -d /usr/lib/X11 ]
	then
		LOC=/usr/lib/X11
	elif [ -d /usr/X/lib ]
	then
		LOC=/usr/X/lib
	elif [ -d /usr/openwin/lib ]
	then
		LOC=/usr/openwin/lib
#	elif [ -d /opt/IXIX11R5/lib ]
#	then
#		LOC=/opt/IXIX11R5/lib
	else
		# X is not installed, so don't do anything.
		echo "No X lib, cannot $OPTION misc" >> $LOG_FILE
		reschedule
		return
	fi
	# Install our copy of the XKeysymDB file if one is not already there.
	if [ ! -f $LOC/XKeysymDB -a -f $STATICMERGE/xc/misc/XKeysymDB ]
	then
		cp $STATICMERGE/xc/misc/XKeysymDB $LOC/XKeysymDB 2>> $LOG_FILE
		chown bin $LOC/XKeysymDB
		chgrp bin $LOC/XKeysymDB
		chmod 444 $LOC/XKeysymDB
	fi

	# Install other files.
	if [ -d $LOC/app-defaults ]
	then
		if [ -f    $STATICMERGE/xc/misc/Win4Lin.xdef ]
		then
			cp $STATICMERGE/xc/misc/Win4Lin.xdef $LOC/app-defaults/Win4Lin \
				2>> $LOG_FILE
		elif [ -f  $STATICMERGE/xc/misc/Merge_uw7.xdef ]
		then
			cp $STATICMERGE/xc/misc/Merge_uw7.xdef $LOC/app-defaults/Merge \
				2>> $LOG_FILE
		elif [ -f  $STATICMERGE/xc/misc/Merge_sco32.xdef ]
		then
			cp $STATICMERGE/xc/misc/Merge_sco32.xdef $LOC/app-defaults/Merge \
				2>> $LOG_FILE
		fi
	fi
	if [ -d $LOC/sco/startup -a -f $STATICMERGE/xc/misc/Merge_scoxrdb.xdef ]
	then
		cp $STATICMERGE/xc/misc/Merge_scoxrdb.xdef \
			$LOC/sco/startup/Merge 2>> $LOG_FILE
	fi
	# Now make sure our files have the right owner and permissions.
	for i in $LOC/app-defaults/Win4Lin \
	         $LOC/app-defaults/Merge $LOC/sco/startup/Merge
	do
		[ ! -f $i ] && continue
		chown bin $i
		chgrp bin $i
		chmod 644 $i
	done
}

Remove_Misc()
{
	rm -f $SS_DIR/inst_misc.sh
	rmdir $SS_DIR > /dev/null 2>&1
	if [ -d /usr/lib/X11 ]
	then
		LOC=/usr/lib/X11
	elif [ -d /usr/X/lib ]
	then
		LOC=/usr/X/lib
	elif [ -d /usr/openwin/lib ]
	then
		LOC=/usr/openwin/lib
#	elif [ -d /opt/IXIX11R5/lib ]
#	then
#		LOC=/opt/IXIX11R5/lib
	else
		# X is not installed, so don't do anything.
		# X is not installed, so don't do anything.
		echo "No X lib, cannot $OPTION misc" >> $LOG_FILE
		return
	fi
	# Don't remove XKeysymDB, because some other package might
	# have re-installed or modified it.

	# Remove the other files installed.
	for i in $LOC/app-defaults/Win4Lin \
	         $LOC/app-defaults/Merge $LOC/sco/startup/Merge
	do
		[ ! -f $i ] && continue
		rm -f ${i}.bak
		echo "Save to $i.bak" >> $LOG_FILE
		mv ${i} ${i}.bak
	done
}

#######################################################################
## MAIN: Start here
##
#######################################################################
PATH=/bin:/usr/bin:/etc:$PATH
export PATH

# Get the VARMERGE and STATICMERGE settings.
. /etc/mrgssv.sh

TDIR=$VARMERGE/tmp
SS_DIR=$VARMERGE/ss
rm -f $SS_DIR/inst_misc.sh

if [ -z "$LOG_FILE" ]
then
	LOG_FILE=$VARMERGE/log/inst_misc.log
	rm -f $LOG_FILE
fi

# When no option, then do installation.
OPTION=$1
OPTION=${OPTION:-install}
REMOVE_OPTION=remove

echo "Misc $OPTION" >> $LOG_FILE

if [ "$OPTION" != "$REMOVE_OPTION" ]
then
	Install_Misc
else
	Remove_Misc
fi
echo "Misc $OPTION done" >> $LOG_FILE

exit 0
