:
# SCCSID(@(#)xmergeset.sh	1.5) Modified 22:21:53 7/12/99
# Borne shell script to set the environment variables needed for xcrt.
# This script must be run as a part of the startup script for X, so
# that the "tty" command will return the actual console name.
# If it is run after X has been started, then the X server must
# have the XSight extentions, so that the "xconsole" program
# can determine the device name of the real console.

if [ -f /etc/mrgssv.sh -o -L /etc/mrgssv.sh ]
then
	. /etc/mrgssv.sh
else
	# This should not happen, but just in case make it safe.
	STATICMERGE=
	VARMERGE=
fi
if [ -z "$XCONSOLENAME" -o ! -c "$XCONSOLENAME/" ]
then
	XCONSOLENAME=
	if [ -x $STATICMERGE/xconsole ]
	then
		XCONSOLENAME=`$STATICMERGE/xconsole`
		if [ $? -ne 0 ]
		then
			XCONSOLENAME=
		fi
	fi
	if [ -z "$XCONSOLENAME" ]
	then
		XCONSOLENAME=`tty`
	fi
fi
export XCONSOLENAME

if [ -x $STATICMERGE/display -a -c $XCONSOLENAME ]
then
	XMERGE=`$STATICMERGE/display $XCONSOLENAME`
else
	if [ -z "$XMERGE" ]
	then
		XMERGE=unknown
	fi
fi
if [ "z$XMERGE" = "ztty" -o "z$XMERGE" = "zunknown" -o "z$XMERGE" = "z" ]
then
	if [ -f $VARMERGE/console.disp ]
	then
		XMERGE=`cat $VARMERGE/console.disp`
	fi
fi
export XMERGE
