
#define NOAPIPROTO
#include "windows.h"
#include "Resources.h"
#include "ModTable.h"
#include "Segment.h"
#include "Log.h"

extern long int Trap();

extern long int GetFileResourceSize();
extern long int GetFileResource();
extern long int GetFileVersionInfoSize();
extern long int GetFileVersionInfo();
extern long int VerFindFile();
extern long int VerInstallFile();
extern long int VerLanguageName();
extern long int VerQueryValue();

 /* Interface Segment Image VER: */
#if defined(TWIN_BIN16)
extern long int IT_GETFILERESOURCESIZE();
extern long int IT_GETFILERESOURCE();
extern long int IT_GETFILEVERSIONINFOSIZE();
extern long int IT_GETFILEVERSIONINFO();
extern long int IT_1UI7LP();
extern long int IT_VERLANGUAGENAME();
extern long int IT_VERQUERYVALUE();

static long int (*seg_image_VER_0[])() =
{	/* nil */	0, 0,
	/* 001 */	Trap, 0,
	/* 002 */	IT_GETFILERESOURCESIZE,		GetFileResourceSize,
	/* 003 */	IT_GETFILERESOURCE,		GetFileResource,
	/* 004 */	Trap, 0,
	/* 005 */	Trap, 0,
	/* 006 */	IT_GETFILEVERSIONINFOSIZE,	GetFileVersionInfoSize,
	/* 007 */	IT_GETFILEVERSIONINFO,		GetFileVersionInfo,
	/* 008 */	IT_1UI7LP,			VerFindFile,
	/* 009 */	IT_1UI7LP,			VerInstallFile,
	/* 00a */	IT_VERLANGUAGENAME,		VerLanguageName,
	/* 00b */	IT_VERQUERYVALUE,		VerQueryValue,
	0
};
#endif

 /* Segment Table VER: */

SEGTAB SegmentTableVER[] =
{	
#if defined(TWIN_BIN16)
	{ (char *) seg_image_VER_0, 88, TRANSFER_CALLBACK, 88, 0, 0 },
#endif
	/* end */	{ 0, 0, 0, 0, 0, 0 }
};

