/*--------------------------------------------------------------------------
**      winspool.h                   Twine           
**              
**------------------------- < License Information > ------------------------
**
**  
**      This file is released under terms of an LGPL.  Readers of 
**  this file may modify or use this source code so long as they make all
**  modifications publically available.  Please refer to TWINE-LICENSE 
**  for further details.
**  
**
**      The original Copyright is in 1999, by CodeWeavers, Inc.
**
**      
**------------------------ < File Content Description > --------------------
**
**  Header:	winspool.h	
**	
**  Description:
**		BLANK TEMPLATE TO MAKE COMPILING MFC GO MORE SMOOTHLY
**		
**
**    
**------------------------- < Revision Information > -----------------------
** $Header: /cVs/Willows/twin/include/winspool.h,v 1.1 1999/03/27 11:50:46 jching Exp $
**
**      Full Revision history at bottom of file
**      
**--------------------------------------------------------------------------*/



/*------------------------- < Full Revision History > ----------------------
** $Log: winspool.h,v $
** Revision 1.1  1999/03/27 11:50:46  jching
** Twine 1.0 merge, new header files.
**
** Revision 1.2  1999/03/25 22:24:20  robf
** prototypes for mfc
**
** Revision 1.1  1999/03/25 20:34:52  jwhite
** Headers files added to support MFC compilation.
**
**
**-------------------------------------------------------------------------*/

#ifndef __winspool_h__ 
#define __winspool_h__ 

typedef struct _PRINTER_DEFAULTS {  // pd  
    LPTSTR      pDatatype; 
    LPDEVMODE   pDevMode; 
    ACCESS_MASK DesiredAccess; 
} PRINTER_DEFAULTS, *LPPRINTER_DEFAULTS;
 
BOOL ClosePrinter(
    HANDLE hPrinter 	// handle to printer object 
   );	

BOOL OpenPrinter(
    LPTSTR pPrinterName,	// pointer to printer or server name 
    LPHANDLE phPrinter,		// pointer to printer or server handle 
    LPPRINTER_DEFAULTS pDefault // pointer to printer defaults structure  
   );	
 
LONG DocumentProperties(
    HWND hWnd,			// handle to window that displays dialog box 
    HANDLE hPrinter,		// handle to printer object 
    LPTSTR pDeviceName,		// pointer to device name 
    PDEVMODE pDevModeOutput,	// pointer to modified device mode structure 
    PDEVMODE pDevModeInput,	// pointer to original device mode structure 
    DWORD fMode 		// mode flag 
   );	

#endif /* __winspool_h__ */
