
set help(General.text) {General
    
VMware Toolbox for Linux is a small application that allows users to change configuration settings within the virtual machine. This application controls the cursor settings and the connection state of removable devices (such as floppy and CDROM).  

The cursor settings allow users to smoothly transition the mouse cursor between the virtual machine and the host graphical user interface. The cursor settings also allow users to copy/paste text buffers between virtual machines and the host. Note that these enhancements are only available when the application is running. 

Another way to access the functions available in the Toolbox window is to right-click the mouse while it is on top of Toolbox window. A single right click will pop-up a menu allowing you to quickly select any Device, Option or Help function. 

To save space on the desktop, it is possible to shrink the Toolbox window to a tiny size (almost the size of an icon) by clicking on the Minimize button. You can 'unshrink' the Toolbox tiny window back to its original size by double-clicking over the tiny window or by selecting the 'Unshrink Window' command from the right-click pop-up menu. 

Clicking on the Help button will open a pop up window with context sensitive help. That text will  also include links to relevant online documents (text in blue - clicking on it will open a browser session and take you to that page).
}

set help(General.urls) {
    {http://www.vmware.com/support/vmwaretools.html
        "VMware Toolbox Online Support"
    }
    {http://www.vmware.com
        "VMware Home Page"
    }
    {http://www.vmware.com/download/downloadtools.html
        "VMware Tools Download Page"
    }
}

set help(Devices.text) {Devices

Lists all removable devices available to the VM and their current state (connected or disconnected).  If the check box next to each device is highlighted then the virtual
machine will be able to access that particular device. The device's state can also be changed by checking or unchecking the device's entry in the popup menu (right mouse button).

The virtual machine cannot access the host system's floppy drive at the same time as when a 2nd virtual machine or the host OS is accessing the floppy drive. If you encounter an error while trying to a connect the floppy drive to the virtual machine, make sure that the device is not mounted by the host OS and that no other virtual machine has access to it.
}

set help(Devices.urls) {
    {http://www.vmware.com/support/vmwaretools.html
        "VMware Toolbox Online Support"
    }
    {http://www.vmware.com
        "VMware Home Page"
    }
    {http://www.vmware.com/download/downloadtools.html
        "VMware Tools Download Page"
    }
}

set help(Options.text) {Options

Lists all available options for windowing behavior and allows these options to be changed.  The allowable options are described in more detail below.

The behavior of the virtual machines's window can be modified by invoking the VMwareToolbox Options button.  The following options are available:

Auto Grab	
----
When enabled, the cursor and keyboard focus are automatically given to the VM whenever the cursor enters the VM's window.

Auto Raise
----
When enabled, the VM's window will be automatically raised to the top of the window stack whenever the cursor and keyboard focus are given to the VM.  If Auto Grab is enabled, then the VM window will be automatically raised when the cursor enters the VM window.

Auto Release
----
When enabled, the cursor and keyboard focus are automatically released when the cursor hits the edge of the VM's window.  This interacts with Auto Scroll as explained below.

Auto Scroll
----
When enabled and there are no scroll bars, then this option has no effect.  However, if there are scrollbars then you get the following behavior.   When the cursor hits the edge of the current view, the VM window will automatically scroll in the direction that the cursor is moving.  Once the cursor hits the physical edge of the VM window, then scrolling will stop.  If Auto Release is enabled, then the cursor and keyboard focus will be released if the cursor hits the real edge of the window.

Copy & Paste
----
When enabled, the selection can be copied and pasted between the VM and the host and between VMs.  This has the side effect that the host's selection is changed to that of the VM, whenever the VM releases the cursor and keyboard focus.  Similarly, the VM's selection is changed to that of the host when the VM is given the cursor and keyboard focus.

Hide Cusor
----
When enabled, the cursor is hidden when the cursor and keyboard focus are released from the VM window.  Since, the cursor cannot actually be made to disappear it is warped to the lower right corner of the VM's window so that it can't be seen.
}

set help(Options.urls) {
    {http://www.vmware.com/support/vmwaretools.html
        "VMware Toolbox Online Support"
    }
    {http://www.vmware.com
        "VMware Home Page"
    }
    {http://www.vmware.com/download/downloadtools.html
        "VMware Tools Download Page"
    }
}



