
namespace eval ::radiobox:: {
    variable Radiobox
    
    set ::radiobox::Radiobox(_proc) {
        set cmd [lshift args]
        
        switch $cmd {
            "configure" {
                ::radiobox::Configure %W $args
            }
            default {
                eval {::radiobox::Radiobox(%W)} {$cmd} $args 
            }
        }        
    }
}

proc ::radiobox::Configure {name varArgs} {
    variable Radiobox

    foreach {op arg} $varArgs {
        switch -exact -- $op {
            "-buttonlist" {
                pack forget [winfo children $name.radios]
                foreach b $Radiobox($name:buttons) {
                    destroy $name.radios.$b
                }
            }
            
            "-label" {
                catch {destroy $name.label}
                label $name.label -text $arg
                pack $name.label -in $name -anchor w
            }

            "-variable" {
                foreach b $Radiobox($name:buttons) {
                    $name.radios.$b configure -variable $arg
                }
            }
            
            default {
                Radiobox($name) configure $op $arg
            }
        }
    }    
}

proc radiobox {name buttonlist args} {
    frame $name -relief flat
    
    frame $name.radios -relief groove -bd 2
    pack $name.radios -in $name -side bottom -fill both -expand 1
    
    rename $name ::radiobox::Radiobox($name)
    
    regsub -all {%W} $::radiobox::Radiobox(_proc) $name body
    proc $name {args} $body

    set ::radiobox::Radiobox($name:columns) 1
    set ::radiobox::Radiobox($name:buttons) {}

    foreach {b text} $buttonlist {
        radiobutton $name.radios.$b -text $text -val $b
        pack $name.radios.$b -in $name.radios -anchor w
        lappend ::radiobox::Radiobox($name:buttons) $b
    }

    ::radiobox::Configure $name $args
    
    set name
}
