
# requires mytcl.tcl
# requires tree.tcl


namespace eval ::tkVis:: {
}

image create photo idir -data {
    R0lGODdhEAAQAPIAAAAAAHh4eLi4uPj4APj4+P///wAAAAAAACwAAAAAEAAQAAADPVi63P4w
    LkKCtTTnUsXwQqBtAfh910UU4ugGAEucpgnLNY3Gop7folwNOBOeiEYQ0acDpp6pGAFArVqt
    hQQAO///
}
image create photo ifile -data {
    R0lGODdhEAAQAPIAAAAAAHh4eLi4uPj4+P///wAAAAAAAAAAACwAAAAAEAAQAAADPkixzPOD
    yADrWE8qC8WN0+BZAmBq1GMOqwigXFXCrGk/cxjjr27fLtout6n9eMIYMTXsFZsogXRKJf6u
    P0kCADv/
}



toplevel .tkvis


wm geometry . +20+20
wm geometry .tkvis +900+20

tree .tkvis.hier -background white -height 8i -width 5i

scrollbar .tkvis.vert -orient vertical -elementborderwidth 2 -bd 0

frame .tkvis.f -relief flat

button .tkvis.f.update -text "Update" -command ::tkVis::Build
button .tkvis.f.exit   -text "Exit  " -command {exit}

pack .tkvis.f -side bottom -fill x
pack .tkvis.f.update .tkvis.f.exit -side left -fill x -expand 1

pack .tkvis.vert -side right -fill y
pack .tkvis.hier -fill both -expand 1

.tkvis.hier configure canvas -yscrollcommand {.tkvis.vert set}
.tkvis.vert configure -command {.tkvis.hier yview}

proc ::tkVis::Build {} {
    catch {destroy .tkvis.hier}
    tree .tkvis.hier -background white -height 8i -width 5i
    pack .tkvis.hier -side top -fill both -expand 1

    set text ". \[[winfo class .]\]"
    .tkvis.hier configure . -text $text -icon idir
    .tkvis.hier bind . <Double-1> { .tkvis.hier open . -children }
    .tkvis.hier bind . <Shift-Double-1> { .tkvis.hier close . -children }
    
    foreach c [winfo children .] {
        ::tkVis::BuildWind $c
    }
}

proc ::tkVis::BuildWind {wind} {

    set w [split $wind "."]
    set tail [lpop w]
    set dir ".[join $w {/}]/$tail"

    set children [winfo children $wind]

    set text "$tail \[[winfo class $wind]\]"
    
    if {$children != {}} {
        .tkvis.hier add $dir -text $text -icon idir -open 0
        
        foreach c $children {
            ::tkVis::BuildWind $c
        }

    } else {
        .tkvis.hier add $dir -text $text -icon ifile
    }
}
